// $Id: util_strings.h,v 1.5 2000/02/14 02:10:13 mian Exp $

#pragma once

inline HRESULT bstrdup(LPOLESTR *wszDest, BSTR bstrSource)
{
	HRESULT hr = E_FAIL;

	if (IsValidWritePtr(wszDest) && IsValidString(bstrSource))
	{
		*wszDest = SysAllocString(bstrSource);
		if (*wszDest == NULL)
		{
			hr = E_OUTOFMEMORY;
		} else {
			hr = S_OK;
		}
	} else {
		hr = E_INVALIDARG;
	}

	return hr;
}

class CAStr
{
public:
	CHAR *m_sz;

	CAStr(const WCHAR *wsz)
	{
		int	cBytes;

		if (IsValidString(wsz))
		{
			cBytes = WideCharToMultiByte(CP_ACP, 0, wsz, -1, NULL, 0, NULL, NULL);
			m_sz = (CHAR *)HeapAlloc(GetProcessHeap(), 0, cBytes+1);
			if (IsValidWritePtr(m_sz))
			{
				cBytes = WideCharToMultiByte(CP_ACP, 0, wsz, -1, m_sz, cBytes+1, NULL, NULL);
				m_sz[cBytes] = 0;
			}
		}
		else
		{
			m_sz = NULL;
		}
	}

	~CAStr()
	{
		if (IsValidReadPtr(m_sz))
		{
			HeapFree(GetProcessHeap(), 0, m_sz);
			m_sz = NULL;
		}
	}
};

class CWStr
{
public:
	WCHAR *m_sz;

	CWStr(const CHAR *asz)
	{
		int	cBytes;

		if (IsValidReadPtr(asz))
		{
			cBytes = MultiByteToWideChar(CP_ACP, 0, asz, -1, NULL, 0);
			m_sz = SysAllocStringLen(NULL, cBytes + 1);
			if (IsValidWritePtr(m_sz))
			{
				cBytes = MultiByteToWideChar(CP_ACP, 0, asz, -1, m_sz, cBytes+1);
				m_sz[cBytes] = 0;
			}
		}
		else
		{
			m_sz = NULL;
		}
	}

	~CWStr()
	{
		if (IsValidString(m_sz))
		{
			SysFreeString(m_sz);
			m_sz = NULL;
		}
	}
};

/*
	$Log: util_strings.h,v $
	Revision 1.5  2000/02/14 02:10:13  mian
	
	Fixed small Read->Write typo
	
	Revision 1.4  2000/02/13 09:36:31  mian
	
	Added more error checking to CAStr/CWStr classes
	
	Revision 1.3  2000/02/13 08:06:27  mian
	
	
	Added log messages
	
*/