// $Id: Core.cpp,v 1.7 2000/02/17 06:37:19 mian Exp $

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "Core.h"

#include "Core_i.c"
#include "HotkeyObject.h"
#include "DesktopObject.h"
#include "MenuObject.h"
#include "ShortcutObject.h"
#include "ShortcutItem.h"
#include "ActiveXObject.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_HotkeyObject, CHotkeyObject)
OBJECT_ENTRY(CLSID_DesktopObject, CDesktopObject)
OBJECT_ENTRY(CLSID_MenuObject, CMenuObject)
OBJECT_ENTRY(CLSID_ShortcutObject, CShortcutObject)
OBJECT_ENTRY(CLSID_ShortcutItem, CShortcutItem)
OBJECT_ENTRY(CLSID_ActiveXObject, CActiveXObject)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        _Module.Init(ObjectMap, hInstance, &LIBID_CORELib);
        DisableThreadLibraryCalls(hInstance);
    }
    else if (dwReason == DLL_PROCESS_DETACH)
        _Module.Term();
    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}

/*
	$Log: Core.cpp,v $
	Revision 1.7  2000/02/17 06:37:19  mian
	
	Added ActiveXObject to core component (use to load ActiveX controls inside any Window)
	
	Revision 1.6  2000/02/17 05:02:39  mian
	
	Added shortcut item
	
	Revision 1.5  2000/02/17 04:34:11  mian
	
	Added shortcut object to core component
	
	Revision 1.4  2000/02/15 15:58:35  mian
	
	Added menu object to core component
	
	Revision 1.3  2000/02/13 08:04:07  mian
	
	Added log messages
	
*/
