// DesktopObject.h : Declaration of the CDesktopObject

#ifndef __DESKTOPOBJECT_H_
#define __DESKTOPOBJECT_H_

#include "resource.h"       // main symbols
#include "DesktopCP.h"

/////////////////////////////////////////////////////////////////////////////
// CDesktopObject
class ATL_NO_VTABLE CDesktopObject : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDesktopObject, &CLSID_DesktopObject>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CDesktopObject>,
	public IProvideClassInfo2Impl<&CLSID_DesktopObject,&DIID__IDesktopObjectEvents,&LIBID_CORELib>,
	public IDispatchImpl<IDesktopObject, &IID_IDesktopObject, &LIBID_CORELib>,
	public CProxy_IDesktopObjectEvents< CDesktopObject >
{
public:
	CDesktopObject();
	virtual ~CDesktopObject();

public:

DECLARE_REGISTRY_RESOURCEID(IDR_DESKTOPOBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CDesktopObject)
	COM_INTERFACE_ENTRY(IDesktopObject)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CDesktopObject)
CONNECTION_POINT_ENTRY(DIID__IDesktopObjectEvents)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IDesktopObject
public:
	STDMETHOD(get_m_hWnd)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_bottom)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_right)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_top)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_left)(/*[out, retval]*/ long *pVal);
	LRESULT WINAPI WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static LRESULT WINAPI ProxyWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	HWND	m_hWnd;
	RECT	m_rectScreen;
};

#endif //__DESKTOPOBJECT_H_
