// HotkeyObject.h : Declaration of the CHotkeyObject

#ifndef __HOTKEYOBJECT_H_
#define __HOTKEYOBJECT_H_

#include "resource.h"       // main symbols
#include <asptlb.h>         // Active Server Pages Definitions
#include "HotkeyCP.h"

/////////////////////////////////////////////////////////////////////////////
// CHotkeyObject
class ATL_NO_VTABLE CHotkeyObject : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CHotkeyObject, &CLSID_HotkeyObject>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CHotkeyObject>,
	public IProvideClassInfo2Impl<&CLSID_HotkeyObject,&DIID__IHotkeyObjectEvents,&LIBID_CORELib>,
	public IDispatchImpl<IHotkeyObject, &IID_IHotkeyObject, &LIBID_CORELib>,
	public CProxy_IHotkeyObjectEvents< CHotkeyObject >
{
public:
	CHotkeyObject();
	virtual ~CHotkeyObject();

public:

DECLARE_REGISTRY_RESOURCEID(IDR_HOTKEYOBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CHotkeyObject)
	COM_INTERFACE_ENTRY(IHotkeyObject)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CHotkeyObject)
CONNECTION_POINT_ENTRY(DIID__IHotkeyObjectEvents)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IHotkeyObject
public:
	STDMETHOD(Remove)(long uID);
	STDMETHOD(Add)(BSTR bstrModifiers, BSTR bstrKey, long uID);

	LRESULT WINAPI WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static LRESULT WINAPI ProxyWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	HWND	m_hWnd;
	RECT	m_rectScreen;
};

#endif //__HOTKEYOBJECT_H_
