// ShortcutObject.h : Declaration of the CShortcutObject

#ifndef __SHORTCUTOBJECT_H_
#define __SHORTCUTOBJECT_H_

#include "resource.h"       // main symbols
#include <asptlb.h>         // Active Server Pages Definitions
#include "../common/util_list.h"
#include "ShortcutCP.h"

/////////////////////////////////////////////////////////////////////////////
// CShortcutObject
class ATL_NO_VTABLE CShortcutObject : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CShortcutObject, &CLSID_ShortcutObject>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CShortcutObject>,
	public IProvideClassInfo2Impl<&CLSID_ShortcutObject,&DIID__IShortcutObjectEvents,&LIBID_CORELib>,
	public IDispatchImpl<IShortcutObject, &IID_IShortcutObject, &LIBID_CORELib>,
	public CProxy_IShortcutObjectEvents< CShortcutObject >
{
public:
	CShortcutObject();
	virtual ~CShortcutObject();

public:

DECLARE_REGISTRY_RESOURCEID(IDR_SHORTCUTOBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CShortcutObject)
	COM_INTERFACE_ENTRY(IShortcutObject)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CShortcutObject)
CONNECTION_POINT_ENTRY(DIID__IShortcutObjectEvents)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IShortcutObject
public:
	STDMETHOD(get_Create)(int x, int y, int cx ,int cy, long hwndParent, /*[out, retval]*/ IShortcutItem* *pVal);
	LRESULT WINAPI WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static LRESULT WINAPI ProxyWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
};

#endif //__SHORTCUTOBJECT_H_
