// $Id: Wave.cpp,v 1.4 2000/02/23 02:06:13 mian Exp $

#include "stdafx.h"
#include "DeskEfx.h"
#include "Wave.h"

/////////////////////////////////////////////////////////////////////////////
// CWave

void CWave::Calculate()
{
	m_nAngleStep=((M_PI_2*2)*m_nWaves)/m_nHeight;
	m_nAmplitude=(m_nHeight/2)/100.0;
}

BOOL CWave::BufferImage(BSTR lpszPath)
{
	if (m_hImageDC) DeleteDC(m_hImageDC);
	if (m_hbmImage) DeleteObject(m_hbmImage);
	m_nWidth = 0;
	m_nHeight = 0;
	m_hbmImage = (HBITMAP)LoadImageFromFile(lpszPath);
	if (m_hbmImage)
	{
		m_hImageDC = CreateCompatibleDC(NULL);
		BITMAP bmInfo;
		GetObject(m_hbmImage, sizeof(bmInfo), &bmInfo);
		m_nWidth = bmInfo.bmWidth;
		m_nHeight = bmInfo.bmHeight;
		SelectObject(m_hImageDC, m_hbmImage);
	}

	Calculate();

	return TRUE;
}

STDMETHODIMP CWave::get_NumWaves(short *pVal)
{
	*pVal = m_nWaves;

	return S_OK;
}

STDMETHODIMP CWave::put_NumWaves(short newVal)
{
	m_nWaves = newVal;
	Calculate();

	return S_OK;
}

STDMETHODIMP CWave::LoadImage(BSTR bstrPath)
{
	BufferImage(bstrPath);

	return S_OK;
}

STDMETHODIMP CWave::get_WaveHeight(short *pVal)
{
	*pVal = m_nWaveHeight;

	return S_OK;
}

STDMETHODIMP CWave::put_WaveHeight(short newVal)
{
	m_nWaveHeight = newVal;

	return S_OK;
}

STDMETHODIMP CWave::get_ImageWidth(long *pVal)
{
	*pVal = m_nWidth;

	return S_OK;
}

STDMETHODIMP CWave::get_ImageHeight(long *pVal)
{
	*pVal = m_nHeight;

	return S_OK;
}

/*
	$Log: Wave.cpp,v $
	Revision 1.4  2000/02/23 02:06:13  mian
	
	Added TIFF decoding the gutil
	Renamed Graphite Utility Library directory to gutil for easier access
	
	Revision 1.3  2000/02/22 09:54:37  mian
	
	Made deskefx use LoadFromFromFile to support more image types
	Started on PCX image decoder
	
	Revision 1.2  2000/02/20 15:21:02  mian
	
	Added DeskEfx to the Graphite workspace, added IE HTML tests
	
*/
